import 'dart:async';

import 'package:firebase_analytics/firebase_analytics.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoorechargeentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leooindexjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoorechargeeventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoonetjunpro/leooapphostjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoomediautilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoorechargeutilsjunpro.dart';
import 'package:provider/provider.dart';

///充值-bottom
class LeooRechargeNewJunPro extends StatefulWidget {
  static bool leooOpenJunPro = false;
  final String? eventName;
  final bool call;

  const LeooRechargeNewJunPro({Key? key, this.eventName, this.call = false})
      : super(key: key);

  @override
  _LeooRechargeState createState() => _LeooRechargeState();
}

class _LeooRechargeState extends State<LeooRechargeNewJunPro> {
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
  late StreamSubscription subscription;
  late String eventName;
  int? userMoney;

  @override
  void initState() {
    super.initState();
    LeooRechargeNewJunPro.leooOpenJunPro = true;
    LeooMediaUtilsJunPro.instance.stopPlayAudio();
    eventName = widget.eventName ?? '充值页面';
    FirebaseAnalytics.instance.logEvent(name: '$eventName点击充值');
    subscription = eventBus.on<LeooRechargeEventJunPro>().listen((event) {
      FirebaseAnalytics.instance.logEvent(name: '$eventName点击进入充值并成功');
      userMoney = event.amount;
      if (widget.call) {
        Navigator.pop(context, userMoney);
      } else {
        status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
        getRechargeList();
      }
    });
    Future(() {
      getRechargeList();
    });
  }

  @override
  void dispose() {
    LeooRechargeNewJunPro.leooOpenJunPro = false;
    subscription.cancel();
    super.dispose();
  }

  void getRechargeList() {
    LeooRechargeUtilsJunPro.instance.getRechargeList(() {}, (type) {
      status = type;
      LeooCodeUtilsJunPro.onSetState(this);
    });
  }

  @override
  Widget build(BuildContext context) {
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      return WillPopScope(
        onWillPop: () {
          Navigator.pop(context, userMoney);
          return Future.value(false);
        },
        child: Container(
          decoration: BoxDecoration(
            color: LeooAppHostJunPro.leooModeJunPro
                ? LeooColorsJunPro.leooAppJunPro
                : LeooColorsJunPro.leooBgJunPro,
            borderRadius: BorderRadius.only(
                topLeft: Radius.circular(30), topRight: Radius.circular(30)),
          ),
          child: Column(
            mainAxisSize: MainAxisSize.min,
            children: <Widget>[
              Stack(
                alignment: Alignment.center,
                children: [
                  LeooAppHostJunPro.leooModeJunPro
                      ? ClipRRect(
                          borderRadius: BorderRadius.only(
                              topLeft: Radius.circular(30),
                              topRight: Radius.circular(30)),
                          child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            LeooIconsJunPro.leooRechargeBgJunPro,
                            width: 1.sw,
                            height: 90.w,
                            fit: BoxFit.cover,
                          ),
                        )
                      : Container(
                          decoration: BoxDecoration(
                            borderRadius: BorderRadius.only(
                                topLeft: Radius.circular(30),
                                topRight: Radius.circular(30)),
                            color: LeooColorsJunPro.leooAppJunPro,
                          ),
                          width: 1.sw,
                          height: 90.w,
                        ),
                  Column(
                    children: [
                      Text(
                        '${userProvider.userEntity.amount ?? 0}',
                        style: LeooTextJunPro.leooGetTextStyleJunPro(
                            30, FontWeight.bold),
                      ),
                      Text(
                        S.of(context).rechargeDiamonds,
                        style: LeooTextJunPro.leooGetTextStyleJunPro(
                            16, FontWeight.bold),
                      ),
                    ],
                  ),
                  Positioned(
                    right: 15.w,
                    child: IconButton(
                      padding: const EdgeInsets.all(0),
                      icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                          LeooIconsJunPro.leooPopCloseJunPro,
                          width: 40.w,
                          height: 40.w),
                      iconSize: 40.w,
                      onPressed:
                          LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        Navigator.pop(context, userMoney);
                      }),
                    ),
                  ),
                ],
              ),
              Stack(
                alignment: Alignment.bottomCenter,
                children: [
                  Container(
                    height: .55.sh,
                    padding: EdgeInsets.only(bottom: 4.w),
                    child: status !=
                            LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
                        ? LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(
                            context, status, onTap: () {
                            status = LeooCommonUtilsJunPro
                                .leooPageStatusLoadingJunPro;
                            LeooCodeUtilsJunPro.onSetState(this);
                            getRechargeList();
                          })
                        : ListView.separated(
                            shrinkWrap: true,
                            physics: const BouncingScrollPhysics(),
                            itemCount: LeooRechargeUtilsJunPro
                                .instance.rechargePay.length,
                            padding: EdgeInsets.fromLTRB(12.w, 12.w, 12.w,
                                LeooAppHostJunPro.leooModeJunPro ? 60.w : 12.w),
                            separatorBuilder:
                                (BuildContext context, int index) {
                              return SizedBox(height: 5.w);
                            },
                            itemBuilder: (BuildContext context, int index) {
                              return getRechargeChildWidget(
                                  LeooRechargeUtilsJunPro
                                      .instance.rechargePay[index],
                                  last: index ==
                                      LeooRechargeUtilsJunPro
                                              .instance.rechargePay.length -
                                          1,
                                  eventName: eventName);
                            },
                          ),
                  ),
                  if (LeooAppHostJunPro.leooModeJunPro)
                    Container(
                      decoration: BoxDecoration(
                        gradient: LinearGradient(
                          begin: Alignment.topCenter,
                          end: Alignment.bottomCenter,
                          colors: [
                            LeooColorsJunPro.leooApp2JunPro.withOpacity(0),
                            LeooColorsJunPro.leooApp2JunPro,
                            LeooColorsJunPro.leooApp2JunPro,
                          ],
                        ),
                        borderRadius: const BorderRadius.only(
                          bottomLeft: Radius.circular(30),
                          bottomRight: Radius.circular(30),
                        ),
                      ),
                      padding: EdgeInsets.fromLTRB(40.w, 18.w, 40.w, 10.w),
                      child: Text(
                        S.of(context).rechargeTip,
                        style: LeooTextJunPro.leooGetTextStyleJunPro(
                            14, FontWeight.bold),
                        textAlign: TextAlign.center,
                      ),
                    ),
                ],
              ),
            ],
          ),
        ),
      );
    });
  }

  Widget getRechargeChildWidget(LeooRechargeEntity item,
      {bool last = false, String? eventName, back}) {
    return InkWell(
      child: Stack(
        alignment: Alignment.topCenter,
        children: [
          Container(
            decoration: BoxDecoration(
              border: item.activity == 1
                  ? Border.all(
                      color: LeooAppHostJunPro.leooModeJunPro
                          ? Colors.white
                          : Colors.transparent,
                      width: 2.w,
                    )
                  : null,
              borderRadius: BorderRadius.circular(20),
              gradient: item.activity == 1
                  ? const LinearGradient(
                      colors: [
                        LeooColorsJunPro.leooRecharge1JunPro,
                        LeooColorsJunPro.leooRecharge2JunPro,
                      ],
                    )
                  : null,
              color: item.activity == 1
                  ? null
                  : LeooAppHostJunPro.leooModeJunPro
                      ? Colors.white
                      : Color(0xFF4E4E4E),
            ),
            margin: EdgeInsets.only(top: 5.w),
            padding: EdgeInsets.all(15.w),
            child: Row(
              children: <Widget>[
                LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooCoinsJunPro,
                  width: 40.w,
                  height: 40.w,
                ),
                SizedBox(width: 10.w),
                Text('${item.originalGold ?? item.gold}',
                    style:
                        LeooAppHostJunPro.leooModeJunPro || item.activity == 1
                            ? LeooTextJunPro.leooGetTextStyleBlackJunPro(
                                24, FontWeight.bold)
                            : LeooTextJunPro.leooGetTextStyleJunPro(
                                24, FontWeight.bold)),
                if ((item.addGold ?? 0) != 0)
                  Text(
                    '+${item.addGold}',
                    style: LeooTextJunPro.leooGetTextStyleYellow2JunPro(
                        24, FontWeight.bold),
                    maxLines: 1,
                    overflow: TextOverflow.ellipsis,
                  ),
                Expanded(child: Container()),
                Container(
                  decoration: BoxDecoration(
                    color: LeooColorsJunPro.leooAppJunPro,
                    borderRadius: BorderRadius.circular(16),
                  ),
                  padding: EdgeInsets.fromLTRB(15.w, 6.w, 15.w, 6.w),
                  child: Text('\$${item.price}',
                      style: LeooTextJunPro.leooGetTextStyleJunPro(
                          20, FontWeight.bold)),
                ),
              ],
            ),
          ),
          if (item.description?.isEmpty == false)
            Container(
              decoration: BoxDecoration(
                color: item.activity == 1
                    ? LeooColorsJunPro.leooOnlineJunPro
                    : LeooColorsJunPro.leooYellowJunPro,
                borderRadius: BorderRadius.circular(8),
                border: Border.all(
                  color: Colors.white,
                  width: 1.w,
                ),
              ),
              padding: EdgeInsets.fromLTRB(5.w, 3.w, 5.w, 2.5.w),
              child: Text(
                item.description ?? '',
                style:
                    LeooTextJunPro.leooGetTextStyleJunPro(12, FontWeight.bold),
              ),
            ),
        ],
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() async {
        if (eventName?.isEmpty == false) {
          FirebaseAnalytics.instance.logEvent(name: '$eventName点击进入充值发起充值');
        }
        LeooRechargeUtilsJunPro.instance
            .connectionInPay(item.code, item.price, inType: '弹窗');
      }),
    );
  }
}
